#include <os.h>
#include "navigation.h"
#include "utils.h"
#include "output.h"

int go_up(char* textbuffer, int pos){
    int x1 = 0, x2 = 0;
    char* p = getline(textbuffer, pos, 0);
    for(; p - textbuffer < pos; p++){
        if(*p == '\t')
            x1 += TAB_WIDTH - (x1 % TAB_WIDTH);
        else
            x1++;
    }
    p = getline(textbuffer, pos, 1);
    for(; x2 < x1 && *p != '\n'; p++){
        if(*p == '\t')
            x2 += TAB_WIDTH - (x2 % TAB_WIDTH);
        else
            x2++;
    }
    return p - textbuffer;
}

int go_down(char* textbuffer, int pos){
    int x1 = 0, x2 = 0;
    char* p = getline(textbuffer, pos, 0);
    for(; p - textbuffer < pos; p++){
        if(*p == '\t')
            x1 += TAB_WIDTH - (x1 % TAB_WIDTH);
        else
            x1++;
    }
    p = strchr(p, '\n') + 1;
    for(; x2 < x1 && *p != '\n' && *p != '\0'; p++){
        if(*p == '\t')
            x2 += TAB_WIDTH - (x2 % TAB_WIDTH);
        else
            x2++;
    }
    return p - textbuffer;
}
